/////////////////////////////////////////////////////////////////////////////////
//
// BkMail.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMail.cpp,v $
 * Revision 1.8  2000/07/13 15:12:23  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 * Revision 1.7  2000/07/07 14:11:54  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 * Revision 1.3  2000/07/05 23:50:31  murayama-s
 * - ؂̎dg݂͂BƂ͏ڍׂȎdllȂ
 *    ȂBclass CSignatureDataǉB܂l̗]n傫
 *    classB
 *
 * Revision 1.6  2000/06/29 15:23:35  syou
 * - class CBkMessageAclass CBkMailPartAclass CBkMail
 *   FindMIMEItemFirst()A FindMIMEItemNext()A ExploreItemTree()A
 *   IsMIMEItem()AȂǂȂǎBׂẮAPGPDecodevO
 *   邽߁BJavaCNnewIuWFNg߂悤
 *   ̂ŁAdeleteȂ΂ȂȂԂA
 *   Ȃ߃Ã΃ǃЃуŃʃł́Atemplate class count_ptr
 *   BA͏O̖{Ƃ肾̂Ȃ̂ŁAŐV
 *   ł͂ȂmȂBŔނWeby[WQƂKv邩
 *   ȁBDecoden̎͂ꂩȂ̂ŁA PGPsdk̃TvvO
 *   Ă (^^;  ܂܂ꂩ炾cc
 *
 * Revision 1.4  2000/06/08 21:47:34  syou
 * CBkMail::GetPGPOriginalText()ɂāAQuoted-PrintableɃGR[h
 * ꂽ\[XLĂꍇAB2̍ēǍiCBkMail::ReloadSource()j
 * sȂ悤ɏCB
 *
 * Revision 1.3  2000/06/08 14:53:36  syou
 * ̐ݒ肪PGP/MIMEɂȂĂƁiԂȂ񂩂jAPGP/MIMEg
 * Ȃ悤ɂĂAContent-Transfer-EncodingQuoted-PrintableɂȂ
 * ܂oOCB0.00.1̖͑ς炸̂܂܁Bt鎞
 * cc
 *
 * Revision 1.2  2000/06/03 04:13:31  syou
 * PGPÍ@\B
 * PGPɁAPGP/MIMEƂłȂ̂̃IvVIsƁA
 * sƂ̏ɖ肪B
 * ̓Iɂ́AContent-TypeۂƈقȂLqɂȂB
 * iQuoted-Printableɂ^C~O̖ccCBkMail̏CKvj
 * ACBkMail̑K͂ȏlĂ̂ŁA
 * 񂵂ɂȂB
 *
 * Revision 1.1.1.1  2000/05/20 16:41:00  syou
 * Ƃ肠An߂܂
 *
 */

#include "BkMail.h"


/////////////////////////////////////////////////////////////////////////////////
//
CBkMail::CBkMail(HWND hWnd)
{
    m_hWnd = hWnd;
    m_lpMailID = NULL;
    m_lpSource = NULL;
    m_pItem = new CMIMEItem();
}


CBkMail::CBkMail(LPCTSTR lpMailID)
{
    m_hWnd = NULL;
    m_lpMailID = strdup(lpMailID);
    m_lpSource = NULL;
    m_pItem = new CMIMEItem();
}


CBkMail::CBkMail(const CBkMail& bm)
{
    m_hWnd = bm.m_hWnd;
    m_lpMailID = bm.m_lpMailID;
    m_lpSource = bm.m_lpSource;
    m_pItem = bm.m_pItem;
}


CBkMail::~CBkMail()
{
    free(m_lpSource);
    m_lpSource = NULL;

    free(m_lpMailID);
    m_lpMailID = NULL;

    delete m_pItem;
    m_pItem = NULL;
}


CBkMail& CBkMail::operator =(const CBkMail& bm)
{
    if (this != &bm) {
        m_hWnd = bm.m_hWnd;
        m_lpMailID = bm.m_lpMailID;
        m_lpSource = bm.m_lpSource;
        m_pItem = bm.m_pItem;
    }
    return *this;
}


BOOL CBkMail::Commit()
{
    if (!m_bChanged) {
        return TRUE;
    }

    if (m_lpSource == NULL) {
        return TRUE;
    }

    free(m_lpSource);
    m_lpSource = m_pItem->ToString();
    if (m_lpSource == NULL) {
        return FALSE;
    }

    if (m_hWnd) {
        m_pbka->CompSetSource(m_hWnd, m_lpSource);
    }
    else {
        m_pbka->SetSource(m_lpMailID, m_lpSource);
    }

    m_bChanged = FALSE;
    return TRUE;
}


LPCTSTR CBkMail::GetContent()
{
    LoadSource();
    LPCTSTR lpContent = strstr(m_lpSource, "\r\n\r\n");
    if (lpContent == NULL) {
        free(m_lpSource);
        m_lpSource = NULL;
        m_lpSource = m_pItem->ToString();
        if (m_lpSource == NULL) {
            return NULL;
        }
        lpContent = strstr(m_lpSource, "\r\n\r\n");
        if (lpContent == NULL) {
            return NULL;
        }
    }
    lpContent += 2;
    return lpContent;
}


LPSTR CBkMail::GetText() const
{
    char szMimeType[80];
    if (m_hWnd) {
        return m_pbka->CompGetText(m_hWnd, szMimeType, 80);
    }
    else {
        return m_pbka->GetText(szMimeType, 80);
    }
}


BOOL CBkMail::SetText(int nMode, LPCTSTR lpszText)
{
    if (!m_bChanged && !Commit()) {
        return FALSE;
    }

    if (m_hWnd) {
        m_pbka->CompSetText(m_hWnd, nMode, lpszText);
    }
    else {
        m_pbka->SetText(nMode, lpszText);
    }

    if (m_lpSource) {
        free(m_lpSource);
        m_lpSource = NULL;
        m_bChanged = FALSE;
    }

    return TRUE;
}


void CBkMail::GetCharSet(LPSTR lpszCharSet, int nBuf) const
{
    if (m_hWnd) {
        m_pbka->CompGetCharSet(m_hWnd, lpszCharSet, nBuf);
    }
    else {
        m_pbka->GetCharSet(m_lpMailID, lpszCharSet, nBuf);
    }
}


void CBkMail::ReloadSource()
{
    m_bChanged = FALSE;
    free(m_lpSource);

    LPSTR lpTemp;
    if (m_hWnd) {
        lpTemp = m_pbka->CompGetSource(m_hWnd);
    }
    else {
        lpTemp = m_pbka->GetSource(m_lpMailID);
    }

    m_lpSource = strdup(lpTemp);
    m_pItem->FromString(lpTemp);
    m_pbka->Free(lpTemp);
}


BOOL CBkMail::IsMIMEItem(LPCTSTR lpszType, LPCTSTR lpszSubType)
{
    LoadSource();
    if ((!lpszType || (lpszType && stricmp(lpszType, m_pItem->m_szType) == 0)) &&
        (!lpszSubType || (lpszSubType && stricmp(lpszSubType, m_pItem->m_szSubType) == 0)) ) {
        return TRUE;
    }
    return FALSE;
}


inline CBkMailPart* CBkMail::FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag)
{
    CMIMEItem* pMimeItem = m_pItem;
    m_listItem.clear();
    LoadSource();
    ExploreItemTree(lpszType, lpszSubType, m_pItem, dwFlag);
    if (m_listItem.empty()) {
        return NULL;
    }

    m_iMimeItem = m_listItem.begin();
    if (m_iMimeItem == m_listItem.end()) {
        return NULL;
    }

    return new CBkMailPart(this, *m_iMimeItem);
}



inline CBkMailPart* CBkMail::FindMIMEItemNext()
{
    if (++m_iMimeItem == m_listItem.end()) {
        return NULL;
    }

    return new CBkMailPart(this, *m_iMimeItem);
}


LPSTR CBkMail::GetPGPOriginalText(BOOL bPGPMIME)
{
    LPSTR lpTxt = NULL;
    if (bPGPMIME) {
        char szEncoding[1024];
        GetHeader("Content-Transfer-Encoding", szEncoding, 1024);
        if (m_hWnd && strnicmp(szEncoding, "Quoted-Printable\r\n", 1024) != 0) {
            SendMessage(m_hWnd, WM_SET_TRANSFER_SAFE, (WPARAM)TRUE, 0);
            ReloadSource();
            GetHeader("Content-Transfer-Encoding", szEncoding, 1024);
        }

        LPCTSTR lpContent = GetContent();
        if (lpContent == NULL || *lpContent == NULL) {
            return NULL;
        }
        lpTxt = (LPSTR) malloc(strlen(lpContent) + 3072);//m_pbka->Alloc(strlen(lpContent) + 3072);
        if (lpTxt == NULL) {
            return NULL;
        }

        char szType[1024];
        GetHeader("Content-Type", szType, 1024);
        sprintf(lpTxt, "Content-Type: %sContent-Transfer-Encoding: %s%s", szType, szEncoding, lpContent);
    }
    else {
        char szCharSet[82];
        LPSTR lpBody = GetText();
        if (lpBody == NULL) {
            return NULL;
        }
        GetCharSet(szCharSet, 80);
        if (stricmp(szCharSet, "ISO-2022-JP") == 0 || (szCharSet[0] == '\0' && GetACP() == 932)) {
            LPSTR lpTemp = m_pbka->ISO_2022_JP(lpBody, TRUE);
            if (lpTemp == NULL) {
                return NULL;
            }
            lpTxt = strdup(lpTemp);
            m_pbka->Free(lpTemp);
        }
        else {
            lpTxt = (LPSTR) malloc(strlen(lpBody) + 1);
            if (lpTxt == NULL) {
                return NULL;
            }
            strcpy(lpTxt, lpBody);
        }
        m_pbka->Free(lpBody);
    }
    return lpTxt;
}


